// Copyright 2007 Google Inc. All Rights Reserved.

import org.mozilla.javascript.*;
import org.mozilla.javascript.debug.*;

class Ex {
  public static void main(String[] args) {
    Context.call(new ContextAction() {
        public Object run(Context context) {
          context.setDebugger(new Debugger() {
              public void handleCompilationDone(
                  Context context,
                  DebuggableScript functionOrScript,
                  String source) {
                System.out.println("executable lines: ");
                for (int lineNumber: functionOrScript.getLineNumbers()) {
                  System.out.println("\t" + lineNumber);
                }
              }

              public DebugFrame getFrame(Context context,
                                   DebuggableScript functionOrScript) {
                return new DebugFrame() {
                  public void onEnter(Context context, Scriptable activation,
                                      Scriptable thisObj, Object[] args) {
                  }

                  public void onLineChange(Context context, int lineNumber) {
                    System.out.println("line change: " + lineNumber);
                  }

                  public void onExceptionThrown(Context context, Throwable ex) {
                  }

                  public void onExit(Context context, boolean byThrow,
                                     Object resultOrException) {
                  }
                  public void onDebuggerStatement(Context cx) {
                      
                  }
                };
              }
            },
            null);
          context.setGeneratingDebug(true);
          context.setOptimizationLevel(-1);

          Scriptable scope = context.initStandardObjects();
          context.evaluateString(scope, "// hello", "file.js", 1, null);
          //context.evaluateString(scope, "function f() {\nreturn 3;\n}\n", "file.js", 1, null);
          return null;
        }
      });
  }
}
